import { Constructor } from '../../../../types/GlobalTypes';
import { BaseController } from './_BaseController';
import { TypedMatNode } from '../_Base';
import { Material } from 'three/src/materials/Material';
import { NodeParamsConfig } from '../../utils/params/ParamsConfig';
export declare function WireframeParamConfig<TBase extends Constructor>(Base: TBase): {
    new (...args: any[]): {
        /** @param toggle on to set material to wireframe */
        wireframe: import("../../utils/params/ParamsConfig").ParamTemplate<import("../../../poly/ParamType").ParamType.BOOLEAN>;
        /** @param define appearance of line ends */
        wireframeLinecap: import("../../utils/params/ParamsConfig").ParamTemplate<import("../../../poly/ParamType").ParamType.INTEGER>;
        /** @param Define appearance of line joints */
        wireframeLinejoin: import("../../utils/params/ParamsConfig").ParamTemplate<import("../../../poly/ParamType").ParamType.INTEGER>;
    };
} & TBase;
declare class WireframedMaterial extends Material {
    wireframe: boolean;
    wireframeLinecap: string;
    wireframeLinejoin: string;
}
declare const WireframeParamsConfig_base: {
    new (...args: any[]): {
        /** @param toggle on to set material to wireframe */
        wireframe: import("../../utils/params/ParamsConfig").ParamTemplate<import("../../../poly/ParamType").ParamType.BOOLEAN>;
        /** @param define appearance of line ends */
        wireframeLinecap: import("../../utils/params/ParamsConfig").ParamTemplate<import("../../../poly/ParamType").ParamType.INTEGER>;
        /** @param Define appearance of line joints */
        wireframeLinejoin: import("../../utils/params/ParamsConfig").ParamTemplate<import("../../../poly/ParamType").ParamType.INTEGER>;
    };
} & typeof NodeParamsConfig;
declare class WireframeParamsConfig extends WireframeParamsConfig_base {
}
declare class WireframedMatNode extends TypedMatNode<WireframedMaterial, WireframeParamsConfig> {
    create_material(): WireframedMaterial;
}
export declare class WireframeController extends BaseController {
    protected node: WireframedMatNode;
    constructor(node: WireframedMatNode);
    static update(node: WireframedMatNode): void;
}
export {};
